import time
import sys
import math
#
if not Misc.CurrentScriptDirectory() in sys.path:
    sys.path.append(Misc.CurrentScriptDirectory())
#
import common
common.Player = Player
common.Target = Target
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
#
from System.Collections.Generic import List
from System import Byte, Int32
#
BallID = 0x0E73
BallColor = 0x0020
#
def findRecursiveWithColor(containerSerial, typeArray):
    ret_list = []
    types = []
    typeColor = []
    for id in typeArray:
        types.append(id[0])
        typeColor.append(id[1])
    #    
    container = Items.FindBySerial(containerSerial)
    if container != None:
        for item in container.Contains:
            try:
                index = types.index(item.ItemID)
                if item.Hue == typeColor[index] or typeColor[index] == -1:
                    ret_list.append(item)
            except ValueError:
                pass    
            if item.IsContainer:
                for tmp in findRecursiveWithColor(item.Serial, typeArray):
                    ret_list.append(tmp)
    return ret_list

#
def fetch():
    balls = findRecursiveWithColor(Player.Backpack.Serial, [ (BallID, BallColor) ])
    if len(balls) > 0:
        ball = balls[0]
        Items.UseItem(ball.Serial)
        Target.WaitForTarget(5000, False)
        Target.TargetExecuteRelative(Player.Serial, 4)
        #Target.TargetExecute(2844, 3544 ,0)
    else:
        Misc.SendMessage("No Ball Found", 20)

LastFeedTime = 0 
def CheckFeedPet(pet):
    global LastFeedTime
    if LastFeedTime + (1*30*60) < time.time():
        LastFeedTime = time.time()
        Cabbage = 0x0C7B 
        Meat = 0x09F1
        foods = common.findRecursive(Player.Backpack.Serial, [ Meat ])
        if len(foods) > 0:
            food = foods[0]
            Items.Move(food, pet, 1)
        else:
            Player.HeadMessage(5, "NO FOOD")    
        
#
pets = common.FindPets()
#
#enemy = Mobiles.FindBySerial(Target.GetLast())
while True:
    enemy = None
    if not enemy:
        enemy_filter = Mobiles.Filter()
        enemy_filter.Enabled = True
        enemy_filter.RangeMin = -1
        enemy_filter.RangeMax = 2
        enemy_filter.Notorieties = List[Byte](bytes([3,4,5,6]))
        #
        enemies = Mobiles.ApplyFilter(enemy_filter)
        remove_mine = []
        for e in enemies:
            owner = Mobiles.GetPropValue(e.Serial, "Owner")
            #Misc.SendMessage("Owner: {}".format(owner))
            if owner == Player.Name:
                remove_mine.append(e)
        if len(remove_mine) != 0:        
            for e in remove_mine:
                enemies.Remove(e)
                Misc.SendMessage("Removed one")
        #Misc.SendMessage("Up CLose Enemies after is {}".format(len(up_close_enemies)))
        if len(enemies) > 0 :
            enemy = Mobiles.Select(enemies, 'Nearest')
            
    if enemy != None:
        Player.SetWarMode(True)
        Player.SetWarMode(False)
        for pet in common.FindPets():
            #Player.ChatSay(5, "{} kill".format(pet.Name))
            Player.ChatSay(5, "all kill")
            Target.WaitForTarget(1000)
            Target.TargetExecute(enemy)
            Mobiles.Message(enemy, 5, "Attacking 0x{:08x}".format(enemy.Serial))
    else:
        Player.HeadMessage(5, "No Enemy")
        pets = common.FindPets()
        if len(pets) > 0:
            pet = pets[0] 
            if Items.BackpackCount(BallID, BallColor): 
                oldExp = Mobiles.GetPropValue(pet, "Experience")    
                fetch()                    
                Misc.Pause(1000)   
                newExp = Mobiles.GetPropValue(pet, "Experience")
                Misc.SendMessage("Exp: {} Gained: {}".format(newExp, newExp - oldExp) )               
                Misc.Pause(2500)
                CheckFeedPet(pet)

    Misc.Pause(1500)